#pragma semicolon 1

#include <sourcemod>
#include <sdktools_tempents>
#include <sdktools_tempents_stocks>
#include <sdktools_engine>

public Plugin:myinfo = 
{
	name	= "Death Beam",
	author	= "wS / World-Source.Ru",
	version	= "1.1",
	url		= "http://world-source.ru/"
};

new g_Laser;
new Handle:death_beam_type;

public OnPluginStart()
{
	death_beam_type = CreateConVar("death_beam_type", "0", "Кто видит луч смерти:\n0 = все; 1 = только жертва; 2 = только убийца; 3 = только жертва и убийца", _, true, 0.0, true, 3.0);
	HookEvent("player_death", player_death);
}

public OnMapStart()
{
	g_Laser = PrecacheModel("materials/sprites/laser.vmt");
}

public player_death(Handle:event, const String:name[], bool:silent)
{
	new killer = GetClientOfUserId(GetEventInt(event, "attacker"));
	if (killer < 1)
		return;

	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	if (killer == victim)
		return;

	new killer_team = GetClientTeam(killer);
	if (GetClientTeam(victim) == killer_team)
		return;

	decl Float:wS_Start[3], Float:wS_End[3], wS_Color[4];
	GetClientEyePosition(killer, wS_Start);
	GetClientEyePosition(victim, wS_End);
	wS_Color[1] = 0;
	wS_Color[3] = 255;
	if (killer_team == 2)
	{
		wS_Color[0] = 255;
		wS_Color[2] = 0;
	}
	else
	{
		wS_Color[0] = 0;
		wS_Color[2] = 255;
	}

	new X = GetConVarInt(death_beam_type);
	TE_SetupBeamPoints(wS_Start, wS_End, g_Laser, g_Laser, 0, 0, 1.0, 2.0, 2.0, 0, 0.0, wS_Color, 1);
	if (X == 0)			TE_SendToAll();
	else if (X == 1)	TE_SendToClient(victim);
	else if (X == 2)	TE_SendToClient(killer);
	else
	{
		TE_SendToClient(victim);
		TE_SendToClient(killer);
	}
}